(function() {
  var imgsMap = {};

  function queryAll(doc, selector) {
    return (doc || document.documentElement).querySelectorAll(selector);
  }

  function query(doc, selector) {
    return (doc || document.documentElement).querySelector(selector);
  }

  function attr(el, name, value) {
    if (!!value) {
      el.setAttribute(name, value);
    } else {
      return el.getAttribute(name);
    }
  }

  function addClass(ele, clsName) {
    ele.className += " " + clsName;
  }

  function removeClass(ele, clsName) {
    ele.className = ele.className.replace(clsName, "");
  }

  window.showInline = function(cid, src) {
    var imgs = imgsMap[cid];
    if (imgs) {
      for (var i = 0; i < imgs.length; ++i) {
        var img = imgs[i];
        removeClass(img, 'peclient-wait-for-download-img');
        img.onload = inlineOnloaded;
        img.src = src;
      }
    }
  }

  handleAllImages();

  function handleAllImages() {
    var imgs = queryAll(document.body, "img");
    var rImap = /^(cid:.*)/i;
    var rWmsvr = /^(imail:.*)/;
    for (var i = 0; i < imgs.length; ++i) {
      var img = imgs[i];
      var src = img.src;
      var key = undefined;
      if (rImap.test(src)) {
        key = src.match(rImap)[1];
      }
      if (!!!key && rWmsvr.test(src)) {
        key = src.match(rWmsvr)[1];
      }
      if (!!key && key.length > 0) {
        if (!imgsMap[key]) {
          imgsMap[key] = [];
        }
        addClass(img, 'peclient-wait-for-download-img');
        imgsMap[key].push(img);
      }
    }
  }

  var delayScaleTaskCount = 0;

  function inlineOnloaded() {
    if (delayScaleTaskCount == 0) {
      delayScaleTaskCount++;
      window.setTimeout(function() {
        delayScaleTaskCount--;
        reScale();
        window.location = "ios:loadinlineAttachmentFinish";
      }, 20);
    }
  }
})();