var ClickOnBlankGesture = {
    create: function() {
        var gesture = {};
        var inputTags = ["input", "textarea"];
        var isInput = function(node) {
            var name = node.nodeName.toLowerCase();
            return -1 != inputTags.indexOf(name);
        }
        gesture.hasDefaultAction = function(target) {
            var defaultAction = false;
            while (!!target) {
                if (!!target.href || target.type == "submit" || isInput(target)) {
                    defaultAction = true;
                    break;
                }
                target = target.parentElement;
            }
            return defaultAction;
        };
        return gesture;
    }
};

var gestureHandler = ClickOnBlankGesture.create();
var isResponeClick = false;

var isInSelectMode = function() {
    var selection = window.getSelection();
    if (!!selection) {
        var selectionString = selection.toString();
        return selectionString.length > 0;
    }
    return false;
};
var touchstartOnBlankArea = function(touch) {
    if (!isInSelectMode()) {
        isResponeClick = true;
    } else {
        isResponeClick = false;
    }
}

var isPermitBlankResponse = false;

function permitBlankResponse() {
    isPermitBlankResponse = true;
    document.body.addEventListener("touchstart", touchstartOnBlankArea)
};

function isTouchBlank(x, y) {
    if (!isPermitBlankResponse) {
        return false;
    }
    if (!isResponeClick || isExtMail()) {
        return false;
    }
    var ele = document.elementFromPoint(x, y)
    if (!!!ele) {
        return true;
    }
    if (isInlineAttachment(ele)) {
        return false;
    }
    return !gestureHandler.hasDefaultAction(ele);
}
