function getParents(el, parentSelector /* optional */ ) {
	if (parentSelector === undefined) {
		parentSelector = document;
	}
	var parents = [];
	var p = el.parentNode;

	while (p !== parentSelector) {
		var o = p;
		parents.push(o);
		p = o.parentNode;
	}
	parents.push(parentSelector);
	return parents;
}

function checkIsClickImg(x, y) {
    if (!isResponeClick || isExtMail()) {
        return null;
    }
    var ele = document.elementFromPoint(x, y);
    if (!!!ele) {
        return null
    }
    if (ele.tagName.toLowerCase() != 'img') {
        return null;
    }
    if (!isInlineAttachment(ele)) {
        return null;
    }
    var parents = getParents(ele);
    for (i = 0; i < parents.length; i++) {
        if (parents[i].tagName == 'A' || parents[i].tagName == 'a') {
            return null;
        }
    }
    return ele.src;
}

function checkIsInlineImg(x, y) {
    if (!isResponeClick || isExtMail()) {
        return null;
    }
    var ele = document.elementFromPoint(x, y);
    if (!!!ele) {
        return null
    }
    if (ele.tagName.toLowerCase() != 'img') {
        return null;
    }
    if (!isInlineAttachment(ele)) {
        return null;
    }
    return ele.src;
}

function checkIsImg(x, y) {
    if (!isResponeClick || isExtMail()) {
        return null;
    }
    var ele = document.elementFromPoint(x, y);
    if (!!!ele) {
        return null;
    }
    if (ele.tagName.toLowerCase() == 'img') {
        return ele.src;
    }
    return null;
}

function checkIsUrl(x, y) {
    if (!isResponeClick || isExtMail()) {
        return null;
    }
    var ele = document.elementFromPoint(x, y);
    if (!!!ele) {
        return null;
    }
    if (ele.tagName.toLowerCase() == 'a') {
        return ele.href;
    }
    var parents = getParents(ele);
    for (i = 0; i < parents.length; i++) {
        if (parents[i].tagName.toLowerCase() == 'a') {
            return parents[i].href;
        }
    }
    return null;
}

