var reformatInfoClass = {
    nemScaleClss: "NE-SCALED",
    nemCHHeightClass: "NE-CH-HEIGHT",
    nemCHTopClass: "NE-CH-TOP",
    nemCHWidthClass: "NE-CH-WIDTH",
    nemLongMailHideClass: "mail_master_long_mail_hide",
    nemLongMailSpreadClass: "nemLongMailSpreadClass",
};

var contentWidth = 0;
var waitBodyTimer = 0;
var curKKTitleHeight = 0;
var firstLoad = true;
var originW = "originW";
var allowRescale = false;
var startTime;
var maxScaleTime = 6000;

window.reScale = function() {
    console.log(">>>>" + window.appHost)
    if (!!window.appHost && !!window.appHost.dontRescale) {
        return;
    }
    console.log(">>>>")
    if (!allowRescale) {
        log("加载JS代码不允许缩放");
        return;
    }
    startTime = new Date();
    log("加载JS代码开始缩放 时间"+startTime);
    cleanAllStyle();
    var retry = startScale();
    // 一些变态的邮件，第一次缩放后，scroll width不会变小，导致页面
    // 显示过小
    if (retry && allowRescale) {
        cleanAllStyle();
        startScale();
    }
    window.location = "ios:rescalefinish";
};

window.setAllowRescale = function(isAllow) {
    allowRescale = isAllow;
    log("加载JS代码设置是否缩放:"+isAllow);
};

window.setMaxWait = function(maxWait) {
    maxScaleTime = maxWait;
};

function queryAll(doc, selector) {
    return (doc || document.documentElement).querySelectorAll(selector);
}

function query(doc, selector) {
    return (doc || document.documentElement).querySelector(selector);
}

function attr(el, name, value) {
    if (!!value) {
        el.setAttribute(name, value);
    } else {
        return el.getAttribute(name);
    }
}

function getStyleRuleValue(style, selector, sheet) {
    var sheets = typeof sheet !== 'undefined' ? [sheet] : document.styleSheets;
    for (var i = 0, l = sheets.length; i < l; i++) {
        var sheet = sheets[i];
        if (!sheet.cssRules) {
            continue;
        }
        for (var j = 0, k = sheet.cssRules.length; j < k; j++) {
            var rule = sheet.cssRules[j];
            if (rule.selectorText && rule.selectorText.split(',').indexOf(selector) !== -1) {
                return rule.style[style];
            }
        }
    }
    return null;
}

function getElementOriWidthOrHeight(ele, name) {
    var w = ele.style[name] || attr(ele, name);
    if (w && w.indexOf("%") == -1) {
        return parseInt(w);
    }
    var cls = ele.classList;
    for (var i = 0; i < cls.length; ++i) {
        var w = getStyleRuleValue(name, "." + cls[i]);
        if (w && w.indexOf("%") == -1) {
            return parseInt(w);
        }
    }
    return null;
}

function addImportantStyle(ele, name, value) {
    ele.style.setProperty(name, value, "important");
}

function cleanStyle(ele, name) {
    ele.style.setProperty(name, "");
}

function addClass(ele, clsName) {
    for (var i = 0; i < ele.classList.length; i++) {
        if (ele.classList[i] == clsName) {
            return;
        }
    }
    ele.className += " " + clsName;
}

function removeClass(ele, clsName) {
    ele.className = ele.className.replace(clsName, "");
}

function needScale(ele) {
    return true;
}

function shouldScaleSelf(ele) {
    var tagName = ele.tagName.toLowerCase();
    return ("table" == tagName) || hasBkImage(ele);
}

function hasBkImage(ele) {
    var style = getComputedStyle(ele);
    var bkimg = style.backgroundImage;
    var bkr = style.backgroundRepeatX;
    return ("none" != bkimg) && (bkr != "repeat-x");
}

function shouldNotSetHeightOnlyForIOS(ele) {
    return ele.classList.contains("iMailDoNotReScale");
}

function canSetHeight(ele) {
    if (shouldNotSetHeightOnlyForIOS(ele)) {
        return false;
    }
    var tags = ["font", "blockquote", "img"];
    var tagName = ele.tagName.toLowerCase();
    return tags.indexOf(tagName) == -1;
}


function tryRemoveWidth(ele, dw, hasFloat) {
    if (hasFloat) {
        return false;
    }
    if (!shouldScaleSelf(ele) && (query(ele, ["[style*='float']"]) == null)) {
        var w = getElementOriWidthOrHeight(ele, "width") || 0;
        attr(ele, originW, w);
        addClass(ele, reformatInfoClass.nemCHWidthClass);
        addImportantStyle(ele, "width", dw + "px");
        addImportantStyle(ele, "height", "auto");
        return true;
    }
    return false;
}

function scaleElement(ele, docWidth, pbw, pwFixed, pzindex, cInfo) {
    if (ele.style.display == "none") {
        return false;
    }
    var w = ele.scrollWidth;
    var doScale = shouldScaleSelf(ele);
    var cc = ele.children;
    var cch = 0;
    var pw = getElementOriWidthOrHeight(ele, "width");
    var zIndex = ele.style.zIndex;
    zIndex = "" == zIndex ? pzindex : zIndex;
    var curWFixed = pwFixed || (null != pw);
    if (cInfo) {
        cInfo.hasFloat = getComputedStyle(ele).float != "none";
    }
    if (doScale) {
        lh = scaleNode(ele, docWidth, cch, pbw, pwFixed, null != pw, false);
    } else {
        var info = {
            hasFloat: false
        };
        for (var i = 0; i < cc.length; ++i) {
            cch += scaleElement(cc[i], docWidth, w, curWFixed, zIndex, info);
        }
        lh = scaleNode(ele, docWidth, cch, pbw, pwFixed, null != pw, info.hasFloat);
    }
    if (zIndex != pzindex) {
        return 0;
    } else {
        return lh;
    }
}

function scaleNode(ele, docWidth, cch, pbw, pwFixed, curWFixed, hasFloat) {
    if (!allowRescale) {
        return false;
    }
    var now = new Date();
    if (now - startTime > maxScaleTime) {
        allowRescale = false;
        sendClientMessage("ios://reScaleTimeout", {
            time: now - startTime
        });
        log("加载JS代码缩放超时返回："+time);
        return false;
    }
    var h = ele.offsetHeight;
    var w = ele.scrollWidth;
    if (needScale(ele) && w > docWidth && (pbw < w || !pwFixed)) {
        var modify = tryRemoveWidth(ele, docWidth, hasFloat);
        if (modify) {
            var h2 = ele.offsetHeight;
            if (h2 > h) {
                cch += (h2 - h);
            }
        }
        if (modify && (cch != 0) && (ele.scrollWidth == w)) {
            w = ele.offsetWidth;
        } else {
            w = ele.scrollWidth;
        }
        if (canSetHeight(ele)) {
            addClass(ele, reformatInfoClass.nemCHHeightClass);
            cch = 0;
        }
        if (w > docWidth) {
            if (!modify) {
                var ow = getElementOriWidthOrHeight(ele, "width") || 0;
                attr(ele, originW, ow);
                addClass(ele, reformatInfoClass.nemCHWidthClass);
            }
            var s = docWidth / w;
            var oldph = ele.parentElement.offsetHeight;
            addImportantStyle(ele, "-webkit-transform", "scale(" + s + ")");
            addImportantStyle(ele, "-webkit-transform-origin", "0px 0px");
            addImportantStyle(ele, "width", w + "px");
            h = ele.offsetHeight;
            var mr = (Math.round(w * (s - 1)) - 1),
                mb = (Math.round(h * (s - 1)) - 1);
            addImportantStyle(ele, "margin-right", mr + "px");
            addImportantStyle(ele, "margin-bottom", mb + "px");
            addClass(ele, reformatInfoClass.nemScaleClss);
            var newph = ele.parentElement.offsetHeight;
            return (oldph - newph + mb + cch + 1);
        }
    } else {
        if (canSetHeight(ele)) {
            addClass(ele, reformatInfoClass.nemCHHeightClass);
            cch = 0;
        }
    }
    log("加载JS代码缩放完成 时间："+ now +" 总时间："+(now - startTime) );
    return cch;
}

function startScale() {
    var docWidth = document.body.offsetWidth;
    if (docWidth <= 0) {
        return;
    }
    var msgDiv = query(undefined, "#peclient-mail-content-ios");
    msgDiv.style.overflowY = "";
    docWidth = msgDiv.offsetWidth;
    var orgScrollW = msgDiv.scrollWidth;
    var cch = scaleElement(msgDiv, docWidth, docWidth, false, msgDiv.style.zIndex);
    var h = msgDiv.scrollHeight;
    if (cch < 0) {
        addClass(msgDiv, reformatInfoClass.nemCHHeightClass);
        cch = 0;
    }
    msgDiv.style.overflowY = "hidden";
    return msgDiv.scrollWidth >= orgScrollW;
}

function tryToResacle() {
    var times = 0;
    waitBodyTimer = setInterval(function() {
        var bodyW = document.documentElement.clientWidth;
        if ((bodyW == contentWidth) || (++times >= 5)) {
            reScale();
            clearInterval(waitBodyTimer);
        }
    }, 100);
}

function adjustAbsoluteTop(nodes, d) {
    for (var i = 0; i < nodes.length; ++i) {
        var node = nodes[i];
        adjustAbsoluteTop(nodes[i].children, d);
        if (node.style.position == "absolute" && node.offsetParent == document.body) {
            var t = parseInt(node.style.top) || d;
            if (!firstLoad || t < d) {
                addClass(node, reformatInfoClass.nemCHTopClass);
                node.style.top = d + "px";
            }
        }
    }
}

function cleanAllStyle() {
    var nodes = queryAll(document.documentElement, "." + reformatInfoClass.nemScaleClss);
    for (var i = 0; i < nodes.length; ++i) {
        var node = nodes[i];
        removeClass(node, reformatInfoClass.nemScaleClss);
        cleanStyle(node, "-webkit-transform");
        cleanStyle(node, "-webkit-transform-origin");
        cleanStyle(node, "margin-right");
        cleanStyle(node, "margin-bottom");
        cleanStyle(node, "height");
        cleanStyle(node, "width");
    }
    nodes = queryAll(document.body, "." + reformatInfoClass.nemCHHeightClass);
    for (var i = 0; i < nodes.length; ++i) {
        var node = nodes[i];
        removeClass(node, reformatInfoClass.nemCHHeightClass);
        cleanStyle(node, "height");
    }
    nodes = queryAll(document.body, "." + reformatInfoClass.nemCHWidthClass);
    for (var i = 0; i < nodes.length; ++i) {
        var node = nodes[i];
        removeClass(node, reformatInfoClass.nemCHWidthClass);
        var w = attr(node, originW);
        if ((parseInt(w) || 0) > 0) {
            addImportantStyle(node, "width", w + "px");
        }
    }
}

function getDOMInfo(option) {
    var baseNode = query(undefined, "#peclient-mail-content-ios");
    var allNodes = queryAll(baseNode, "*");
    var finalNodeArr = [];
    var result = {
        hiddenNode: 0,
        blankNode: 0,
        finalNode: 0,
        deep: 0,
        sum: 0,
        nodeType: {},
        weight: 0
    };
    var nodeTypeArr = [];
    var finalNodeDeep = [];

    nodeTypeArr = option.nodeTypeArr.map(function(t) {
        var type = t.toUpperCase();
        result.nodeType[type] = 0;
        return type;
    });

    Array.prototype.forEach.call(allNodes, function(t, idx) {
        if (getComputedStyle(t).display === "none") {
            result.hiddenNode++;
            return true;
        }

        result.sum++;
        if (t.childNodes.length === 0) {
            result.blankNode++;
        }
        if (t.children.length === 0) {
            result.finalNode++;
            finalNodeArr.push(t);
        } else {
            var isAllChildHidden = Array.prototype.every.call(t.children, function(t, idx) {
                return (getComputedStyle(t).display === "none");
            });

            if (isAllChildHidden) {
                result.finalNode++;
                finalNodeArr.push(t);
            }
        }
        if (nodeTypeArr.indexOf(t.nodeName) !== -1) {
            result.nodeType[t.nodeName]++;
        }
    });

    finalNodeArr.forEach(function(t) {
        var deep = 0;
        while (t !== baseNode) {
            deep++;
            t = t.parentElement;
        }
        finalNodeDeep.push(deep);
        result.weight += (deep + 1) * (deep / 2);
    });

    result.deep = Math.max.apply(null, finalNodeDeep);
    return JSON.stringify(result);
}

function hiddenNode(index) {
    var baseNodeSelector = "#peclient-mail-content-ios";
    var baseNode = query(undefined, baseNodeSelector);
    var allNodes = queryAll(baseNode, "*");
    var flagNode = null;
    var flagNodeIdx = null;
    Array.prototype.forEach.call(allNodes, function(t, idx) {
        if (idx > index) {
            addClass(t, reformatInfoClass.nemLongMailHideClass);
        } else if (idx == index) {
            flagNode = t;
        }
    });
    Array.prototype.forEach.call(flagNode.parentElement.childNodes, function(t, idx) {
        if (flagNode == t) {
            flagNodeIdx = idx;
        } else if (flagNodeIdx && (idx > flagNodeIdx)) {
            addClass(t, reformatInfoClass.nemLongMailHideClass);
        }
    });
}

function deHiddenNode() {
    var baseNodeSelector = "#peclient-mail-content-ios";
    var baseNode = query(undefined, baseNodeSelector);
    var allNodes = queryAll(baseNode, "*");
    Array.prototype.forEach.call(allNodes, function(t, idx) {
        removeClass(t, reformatInfoClass.nemLongMailHideClass);
    });
}

function insertSpreadButton() {
    var insertIframe = '<iframe src="reader_spread.html" frameborder="no" border="0" marginwidth="0" marginheight="0" scrolling="no" allowTransparency="true" style="overflow:hidden; height: 45px;"></iframe>'
    var iframe = document.createElement('div');
    iframe.innerHTML = insertIframe;
    addClass(iframe, reformatInfoClass.nemLongMailSpreadClass);

    var baseNodeSelector = "#peclient-mail-content-ios-container";
    var baseNode = query(undefined, baseNodeSelector);
    baseNode.appendChild(iframe);
}

function removeSpreadButton() {
    var spreadDiv = query(undefined, '.' + reformatInfoClass.nemLongMailSpreadClass);
    spreadDiv.parentElement.removeChild(spreadDiv);
}
//打印日志
function log(msg){
    window.myfunction.log(msg);
}
